---
title: If-None-Match
slug: Web/HTTP/Headers/If-None-Match
tags:
  - Conditional Requests
  - HTTP
  - HTTP Header
  - Reference
  - Request header
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>If-None-Match</code></strong> HTTP request header makes the request conditional. For {{HTTPMethod("GET")}} and {{HTTPMethod("HEAD")}} methods, the server will send back the requested resource, with a {{HTTPStatus("200")}} status, only if it doesn't have an {{HTTPHeader("ETag")}} matching the given ones. For other methods, the request will be processed only if the eventually existing resource's {{HTTPHeader("ETag")}} doesn't match any of the values listed.</p>

<p>When the condition fails for {{HTTPMethod("GET")}} and {{HTTPMethod("HEAD")}} methods, then the server must return HTTP status code 304 (Not Modified). For methods that apply server-side changes, the status code 412 (Precondition Failed) is used. Note that the server generating a 304 response MUST generate any of the following header fields that would have been sent in a 200 (OK) response to the same request: Cache-Control, Content-Location, Date, ETag, Expires, and Vary.</p>

<p>The comparison with the stored {{HTTPHeader("ETag")}} uses the <em>weak comparison algorithm</em>, meaning two files are considered identical if the content is equivalent — they don't have to be identical byte for byte. For example, two pages that differ by the date of generation in the footer would still be considered as identical.</p>

<p>When used in combination with {{HTTPHeader("If-Modified-Since")}}, <strong><code>If-None-Match</code></strong> has precedence (if the server supports it).</p>

<p>There are two common use cases:</p>

<ul>
 <li>For {{HTTPMethod("GET")}} and {{HTTPMethod("HEAD")}} methods, to update a cached entity that has an associated {{HTTPHeader("ETag")}}.</li>
 <li>For other methods, and in particular for {{HTTPMethod("PUT")}}, <code>If-None-Match</code> used with the <code>*</code> value can be used to save a file not known to exist, guaranteeing that another upload didn't happen before, losing the data of the previous put; this problem is a variation of the <a href="https://www.w3.org/1999/04/Editing/#3.1">lost update problem</a>.</li>
</ul>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Request header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">If-None-Match: "&lt;etag_value&gt;"
If-None-Match: "&lt;etag_value&gt;", "&lt;etag_value&gt;", …
If-None-Match: *</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>&lt;etag_value&gt;</dt>
 <dd>Entity tags uniquely representing the requested resources. They are a string of ASCII characters placed between double quotes (Like <code>"675af34563dc-tr34"</code>) and may be prefixed by <code>W/</code> to indicate that the weak comparison algorithm should be used (This is useless with <code>If-None-Match</code> as it only uses that algorithm).</dd>
 <dt><code>*</code></dt>
 <dd>The asterisk is a special value representing any resource. They are only useful when uploading a resource, usually with {{HTTPMethod("PUT")}}, to check if another resource with the identity has already been uploaded before.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="notranslate">If-None-Match: "bfc13a64729c4290ef5b2c2730249c88ca92d82d"

If-None-Match: W/"67ab43", "54ed21", "7892dd"

If-None-Match: *
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7232", "If-None-Match", "3.2")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Conditional Requests</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.If-None-Match")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("ETag")}}</li>
 <li>{{HTTPHeader("If-Unmodified-Since")}}</li>
 <li>{{HTTPHeader("If-Modified-Since")}}</li>
 <li>{{HTTPHeader("If-Match")}}</li>
 <li>{{HTTPStatus("304")}}<code> Not Modified</code></li>
 <li>{{HTTPStatus("412")}}<code> Precondition Failed</code></li>
</ul>
